import 'dart:convert';
import 'request.dart';
import 'response.dart';

abstract class Converter<T> {
  Request convertRequest(Request request) {
    return request;
  }

  Response<T> convertResponse(Response response);
}

class JsonConverter<T> extends Converter<T> {
  @override
  Request convertRequest(Request request) {
    return request;
  }

  @override
  Response<T> convertResponse(Response response) {
    final bodyStr = response.bodyString;
    final body = json.decode(bodyStr);

    if (body is Iterable) {
    } else if (body is Map) {}

    return response.copyWith<T>(body: body);
  }
}
